#!/usr/bin/python2.5
#-*-coding:utf-8-*-
#IS:text.source.python
#AUTHOR:Filip Štědronský, S31


from __future__ import division

import sys,os
from Tix import *
from tkFileDialog import *
from tkMessageBox import *

def check_save(): #nabítnout uložení změněného souboru
    global modified
    if not modified: return True
    r=askquestion(u"Soubor změněn", u"Soubor nebyl uložen od poslední změny. Chcete jej uložit ?", type=YESNOCANCEL)
    if r==CANCEL: return False
    if r==YES: save()
    modified=False
    return True

def exit():
    if not check_save(): return
    sys.exit()

fn=None
modified=False

takt=1.
noty=[]

def load():
    global fn, modified, takt, noty
    f=askopenfilename(master=h, title=u"Otevřít skladbu")
    if not f: return
    if not check_save(): return
    fn=f
    modified=False
    try: 
        fd=open(f, 'r')
    except: 
        showerror(u"Chyba", u"Soubor nelze načíst")
        return
    head=True #načíst hlavičku - takt
    noty=[]
    for i in fd:
        l=i.strip() #oříznout whitespace
        if not l: continue #přeskočit prázdné
        if head:
            if l not in ("3/4", "4/4", "5/4"):
                showerror(u"Chybný vstup", u"Chybná délka taktu. Resetuji na 4/4.")
                takt=1.
            c,j=map(float, l.split('/'))
            takt=c/j
            print takt
            head=False
            continue
        vyska,delka=l.split(u" ")
        delka=float(delka)
        if delka not in (0.5,1,1.5,2,3,4):
            showerror(u"Chybný vstup", u"Chybná délka noty: %r. Přeskakuji."%delka)
            continue
        if vyska not in ("C", "Cis", "D", "Dis", "E", "F", "Fis", "G", "Gis", "A", "Ais", "H", 'c', 'cis', 'd', 'dis', 'e', 'f', 'fis', 'g', 'gis', 'a', 'ais', 'h', 'pomlka'):
            showerror(u"Chybný vstup", u"Chybná výška noty: %r. Přsekakuji."%vyska)
            continue
        noty.append((vyska,delka))
    retitle()
    kresli()


def saveto(fn):
    try:
        f=open(fn, 'w')
    except:
        showerror("Chyba", u"Soubor nelze otevřít pro zápis")
        return
    t=int(takt*4)
    f.write("%d/4\n"%t)
    for v,d in noty:
        if int(d)==d: d=int(d) #převést na celé číslo
        f.write("%s %s\n"%(v,d))
    f.close()

def savecopy():
    f=asksaveasfilename(master=h, title="Uložit kopii skladby")
    if not f: return
    saveto(f)

def saveas(): 
    global fn
    f=asksaveasfilename(master=h, title="Uložit kopii skladby")
    if not f: return
    fn=f
    saveto(f)
    retitle()


def save():
    global fn
    if fn is None: return saveas()
    else: saveto(fn)


def retitle():
    if fn is None: h.title("Editor not")
    else: h.title("Editor not: "+fn)
    

NA_CARU=19 #horizontální místo pro taktovou čáru
PUL_CARY=9 #odečtení přesahu koncovéé taktové čáry
NA_KLIC=20
NA_TAKT=27
UV_MEZERA=5
BEG=3 #místo na začátku
NA_UVOD=BEG+NA_KLIC+UV_MEZERA+NA_TAKT
YB=2
YF=3.5
MEZERA=11. #relativní mezera mezi notami
NA_TECKU=7
PY={0.5: 24, 1.0: 20, 2.0:26, 4.0: 22} #y-souřadnice pomlk dle délka
def image(i):
    return PhotoImage(master=h, name=i, file=os.path.join(os.path.dirname(__file__), "img", i+".gif"))

def kresli():
    c.delete(ALL) #pročistí plátno
    takty=[]
    s=0.0 #součet délek v aktuálním taktu
    buf=[] #noty pro aktuální takt
    w=NA_UVOD
    for v,d in noty: #rozdělí na takty a spočítá část šířky (bez šířky not)
        buf.append((v,d))
        s+=d
        if s>=takt*4:
            takty.append(buf)
            buf=[]
            s=0.0
            w+=NA_CARU
    if buf:
        takty.append(BUF)
        w+=NA_CARU
    w-=PUL_CARY #opraví, aby notové linky nepřesahovaly poslední čáru
    print takty
    
   
    c.create_image(BEG+1, 5, image=IMG_KLIC, anchor="nw")
    c.create_image(BEG+NA_KLIC+UV_MEZERA+1, 18, image=IMG_TAKT[takt], anchor="nw")
    x=NA_UVOD
    for i in takty:
        for v,d in i:
            if v=='pomlka':
                pomlka=True
                idx=6 #pro tečky - 2. mezera
            else:
                pomlka=False
                krizek=v.endswith('is')
                pismeno=v[0]
                prevod='hagfedcHAGFEDC' #převod písmene na index linky/mezery odzhora
                idx=prevod.index(pismeno)
                if pismeno in ('a', 'h'):
                    pomocna=15-7 #horní pomocná linka
                elif pismeno=='C':
                    pomocna=43+7 #dolní pomocná linka
                else:
                    pomocna=None
            tecka=False
            od=d
            #převod nestandartních délek na tečky
            if d==1.5:
                d=1
                tecka=True
            if d==3:
                d=2
                tecka=True
            if idx<7:
                dolu=True
            else:
                dolu=False
            I=None
            if pomlka:
                I=POMLKY[d]
                Y=PY[d]
            elif d==4: 
                Y=int(YB+YF*idx)
                if krizek:
                    Y-=5
                I=NOTY[4.0, krizek]
            else:
                I=NOTY[d,krizek,dolu]
                if dolu: 
                    Y=int(YB+YF*idx) #k základní souřadnici první noty (h) přičteme konstantu násobenou rozdílem dané noty od h
                    if krizek: Y-=6 #křížek nepříjemně mění počátek souřadnic v souboru - vše je třeba posunout nahoru
                else: 
                    Y=int(YB+YF*idx-I.height()+YF*2+1) #rozdíl velikosti části noty mezi linkami (2*skok) a výškou - posun
            mezera=int(od*MEZERA)
            if tecka: mezera+=NA_TECKU
            if I:
                if pomocna is not None:  
                    c.create_line(int(x-4), pomocna, x+I.width()+4, pomocna) #pomocná linka
                c.create_image(x, Y, image=I, anchor="nw") #vykreslí obrázek noty
                OY=int(YB+YF*idx)
                if idx%2==1: #na lince není ideální kreslit tečku přímo vedle -> posunout vertikálně
                    if dolu: 
                        OY-=2
                    else:
                        OY+=2
                if tecka: c.create_oval(x+I.width()+2,OY+1,x+I.width()+5,OY+4,fill="black")#nakresli tečku
                x+=I.width()+mezera
                w+=I.width()+mezera #přičte k šířce, do které při prvním počítání nebyly zahrnuty neznámé šířky not
                
        c.create_line(x+9, 15, x+9, 43)
        x+=NA_CARU
    c['width']=w
    for y in range(15, 44, 7):
        c.create_line(0,y,w,y)
   
#TABULKA PRO TRANSPOZICI
TTAB=["C", "Cis", "D", "Dis", "E", "F", "Fis", "G", "Gis", "A", "Ais", "H", 'c', 'cis', 'd', 'dis', 'e', 'f', 'fis', 'g', 'gis', 'a', 'ais', 'h']

def transp(up):
    global noty
    kr=kroky.get()
    if not up: kr=-kr
    print u"Transponuji o",kr,u"kroků"
    nn=[] #dočasné pole transponovaných not, nutné kvůli přerušení v případě netransponovatelnosti
    for v,d in noty:
        if v=="pomlka": 
            nn.append((v,d))
            continue
        idn=TTAB.index(v)
        nid=idn+kr
        try:
            if nid<0: raise IndexError #např. -1 může být platným indexem, označuje poslední prvek pole, -2 předposlední, etc. Tomu je třeba zabránit.
            novanota=TTAB[nid]
        except IndexError:
            showerror(u"Chyba transpozice", u"Transpozici není možné provést")
            return
        nn.append((novanota,d))
    noty=nn
    kresli()
def tup():
    transp(True)
def tdn():
    transp(False)

h=Tk()
retitle()

IMG_KLIC=image("klic")
IMG_TAKT={}
IMG_TAKT[3/4.]=image("takt_3")
IMG_TAKT[1.]=image("takt_4")
IMG_TAKT[5/4.]=image("takt_5")
NOTY={} #klíče: délka, křížek T/F, dolů T/F
NOTY[0.5, False, False]=image("nota_nahoru_0")
NOTY[1.0, False, False]=image("nota_nahoru_1")
NOTY[2.0, False, False]=image("nota_nahoru_2")

NOTY[0.5, False, True]=image("nota_dolu_0")
NOTY[1.0, False, True]=image("nota_dolu_1")
NOTY[2.0, False, True]=image("nota_dolu_2")

NOTY[0.5, True, False]=image("nota_krizek_nahoru_0")
NOTY[1.0, True, False]=image("nota_krizek_nahoru_1")
NOTY[2.0, True, False]=image("nota_krizek_nahoru_2")

NOTY[0.5, True, True]=image("nota_krizek_dolu_0")
NOTY[1.0, True, True]=image("nota_krizek_dolu_1")
NOTY[2.0, True, True]=image("nota_krizek_dolu_2")

NOTY[4.0, True]=image("nota_krizek_4")
NOTY[4.0, False]=image("nota_4")

POMLKY={}
POMLKY[0.5]=image("pomlka_0")
POMLKY[1.0]=image("pomlka_1")
POMLKY[2.0]=image("pomlka_2")
POMLKY[4.0]=image("pomlka_4")

h.minsize (600,200)
h.maxsize (800,300)
panel=Frame(h)

Button(panel, text=u"Načíst...", command=load).pack(side=LEFT)
Button(panel, text=u"Uložit", command=save).pack(side=LEFT)
Button(panel, text=u"Uložit jako...", command=saveas).pack(side=LEFT)
Button(panel, text=u"Uložit kopii...", command=savecopy).pack(side=LEFT)
Button(panel, text=u"Konec", command=exit).pack(side=RIGHT)



panel.pack(side=TOP, fill=X)


cf=ScrolledWindow(h)
c=Canvas(cf.window, bg="white", height=56)
c.pack(side=TOP, fill=X)

#sb=Scrollbar(cf, orient="h", command=c.xview)
#c["xscrollcommand"]=sb.set
#sb.pack(side=TOP, fill=X)

cf.pack(side=TOP, fill=X)

opf=Frame(h) #panel pro operace
tf=Frame(opf, relief="sunken") #panel transpozice
Label(tf, text="TRANSPOZICE", fg="darkblue").pack(side=TOP)
Label(tf, text="Počet kroků: ").pack(side=TOP)
kroky=IntVar(h)
cntrl=Control(tf, min=1, max=13, variable=kroky)
cntrl.pack(side=TOP)
kroky.set(1)
tbf=Frame(tf)
Button(tbf, text="Transponovat nahoru", command=tup).pack(side=LEFT, fill=X)
Button(tbf, text="Transponovat dolů", command=tdn).pack(side=LEFT, fill=X)
tbf.pack(side=TOP, fill=X)
tf.pack(side=LEFT,fill=Y)
opf.pack(side=TOP,fill=X)

kresli()

h.protocol("WM_DELETE_WINDOW", exit)
h.mainloop()
